﻿-- Author      : Nogarder
-- Create Date : 2013/4/27 15:19:13
NPA_Options.RegisterPageFunc("Core",function()
	--localization
	local Localization=NPA_Options.Localization.PagesMainCore
	--
	local parent=NPA_Options.MainFrame
	--main page
	local main=NPA_Options.Template.CreateFrameWithBar(NPA_Options.MainFrame,nil,410,410,nil,nil,nil,nil,NPA_Options.MainFrame)
	main:Hide()
	--
	local page=main.Frame
	--
	local ModuleList={}
	local CollectorList={}
	--
	--save
	local savebutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Save")
	savebutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	--reset
	local resetbutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Reset")
	resetbutton:SetPoint("TOPRIGHT",page,"TOPRIGHT",-5,-5)
	--cancel
	local cancelbutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Cancel")
	cancelbutton:SetPoint("LEFT",savebutton,"RIGHT",5,0)
	cancelbutton:SetPoint("RIGHT",resetbutton,"LEFT",-5,0)
	--
	local nameplatemodulelist=NPA_Options.Template.CreateCheckBoxList(page,170,330)
	nameplatemodulelist.Scroll:SetPoint("TOPLEFT",savebutton,"BOTTOMLEFT",0,-25)
	NPA_Options.Template.SetCheckBoxList(nameplatemodulelist)
	--
	local modulelistlabel=page:CreateFontString()
	modulelistlabel:SetFont(GameFontNormal:GetFont())
	modulelistlabel:SetText(Localization["NamePlateModule"])
	modulelistlabel:SetPoint("BOTTOM",nameplatemodulelist.Scroll,"TOP",0,5)
	--
	local datacollectorlist=NPA_Options.Template.CreateCheckBoxList(page,170,330)
	datacollectorlist.Scroll:SetPoint("TOPRIGHT",resetbutton,"BOTTOMRIGHT",-20,-25)
	NPA_Options.Template.SetCheckBoxList(datacollectorlist)
	--
	local datacollectorlabel=page:CreateFontString()
	datacollectorlabel:SetFont(GameFontNormal:GetFont())
	datacollectorlabel:SetText(Localization["DataCollector"])
	datacollectorlabel:SetPoint("BOTTOM",datacollectorlist.Scroll,"TOP",0,5)
	--
	nameplatemodulelist.OnValueUpdateFunc=function(name,checked)
		ModuleList[name]=checked
	end
	--
	datacollectorlist.OnValueUpdateFunc=function(name,checked)
		CollectorList[name]=checked
	end
	--
	local Load=function(default)
		local entry
		if(default)then
			entry=NPA.SettingManager.GetDefault("Core")
		else
			entry=NPA_Setting.Core
		end
		ModuleList=CopyTable(entry.NamePlateModules)
		CollectorList=CopyTable(entry.DataCollectors)
		NPA_Options.Template.UpdateCheckBoxList(nameplatemodulelist,ModuleList,Localization)
		NPA_Options.Template.UpdateCheckBoxList(datacollectorlist,CollectorList,Localization)
	end
	--
	local Save=function()
		NPA_Setting.Core.NamePlateModules=CopyTable(ModuleList)
		NPA_Setting.Core.DataCollectors=CopyTable(CollectorList)
		--fire event
		NPA.EventHandler.FireEvent(6,"ProfileManager_ProfileLoaded")
		Load()
	end
	--
	savebutton:HookScript("OnMouseUp",Save)
	resetbutton:HookScript("OnMouseUp",function()
		Load(true)
	end)
	--
	main.OnSetFunc=function()
		Load()
	end
	--
	NPA_Options.RegisterPage("Core",main)
end)
