﻿-- Author      : Nogarder
-- Create Date : 2012/11/4 7:53:23
NPA_Options.RegisterPageFunc("SpellLibLibEditor",function()

	local pairs=pairs
	local CopyTable=CopyTable
	local table_insert=table.insert
	--localization
	local Localization=NPA_Options.Localization.PagesResourcesLibSpellLib
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	--
	local main=NPA_Options.Template.CreateFrameWithBar(parent,Localization["SelectType"],150,240,nil,nil,nil)
	main:Hide()
	local listeditor=NPA_Options.Template.CreateListEditor(main.Frame,nil,150,240,main,nil,true)
	--
	local GetSortData=function()
		return Localization["SortData"]
	end
	--
	local sortbydropdown=NPA_Options.Template.CreateDropDownEditor(main.Scroll,170,Localization["SortBy"],Tooltips["SortBy"],GetSortData)
	sortbydropdown:SetPoint("BOTTOM",main.Scroll,"TOP",0,15)
	NPA_Options.Template.SetDropDownEditor(sortbydropdown,0)
	--script
	local Refresh=function()
		--build data
		local typelist={}
		--build data
		if(sortbydropdown.Value==0)then
			--sort by catalog
			for _,spelldata in pairs(NPA_Setting.SpellLib)do
				typelist[spelldata.Catalog]=true
			end
		elseif(sortbydropdown.Value==1)then
			--sort by dr type
			for _,spelldata in pairs(NPA_Setting.SpellLib)do
				typelist[spelldata.PVPDRType]=true
			end
		elseif(sortbydropdown.Value==2)then
			--sort by dr type
			for _,spelldata in pairs(NPA_Setting.SpellLib)do
				typelist[spelldata.SpellType]=true
			end
		elseif(sortbydropdown.Value==3)then
			--sort by dr type
			for _,spelldata in pairs(NPA_Setting.SpellLib)do
				typelist[spelldata.School]=true
			end
		end
		local data={}
		for name,_ in pairs(typelist)do
			if(sortbydropdown.Value==0)then
				table_insert(data,{
					Text=name,
					Value=name,
				})
			elseif(sortbydropdown.Value==1)then
				table_insert(data,{
					Text=NPA_Options.Localization.InfoLibSpell.DrType[name] or name,
					Value=name,
				})
			end
		end
		NPA_Options.Template.UpdateListEditor(listeditor,data)
	end
	--
	sortbydropdown.OnValueUpdateFunc=Refresh
	--
	listeditor.RefreshFunc=Refresh
	listeditor.OnClickFunc=function(value,button)
		if(button=="LeftButton")then
			--setup editor page
			NPA_Options.SetPage("SpellSelector",main,value,nil,sortbydropdown.Value)
		end
	end
	--on zip and unzip
	main.Scroll.OnMinimizedFunc=function()
		sortbydropdown:Hide()
	end
	main.Scroll.OnRestoredFunc=function()
		sortbydropdown:Show()
	end
	--
	main.OnSetFunc=function(name)
		if(name)then
			Refresh()
			NPA_Options.Template.SetSelectListFocus(listeditor,name)
			NPA_Options.SetPage("SpellSelector",main,name,nil,0)
		end
	end
	----
	NPA_Options.RegisterPage("SpellLibLibEditor",main)

end)